package pl.net.linux.krzak.kchat.applet;

import java.applet.Applet;
import java.applet.AppletContext;
import java.applet.AppletStub;
import java.awt.Frame;
import java.awt.Button;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Color;
import java.awt.List;
import java.awt.Dimension;
import java.awt.Label;
import java.awt.Scrollbar;
import java.awt.Image;
import java.awt.Graphics;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.AdjustmentEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.lang.String;
import java.util.Vector;
import java.util.Hashtable;
import pl.net.linux.krzak.kchat.util.MessagesClass;
import pl.net.linux.krzak.kchat.util.kChatTextArea;
import pl.net.linux.krzak.kchat.util.kButton;

public class kChatApplet extends Applet implements KeyListener, MouseListener, Runnable {
  Thread appletThread;
  public kChatNet net 		= null;
  public kChatTextArea chanWnd 	= null;
  public kChatModerator moder 	= null;
  public Scrollbar sbar 	= new Scrollbar(Scrollbar.VERTICAL,0,0,0,0);
  public String login 		= "any";
  public String chan  		= "free";
  public String alertColor 	= "#0F1761";
  public String msgColor 	= "#cccccc";
  public List nList 		= null;
  public boolean moderate 	= false;
  public String moderatorNick 	= new String();
  public String selectedNick 	= new String();
  public Vector windowsList 	= new Vector();
  public String TXT[] 		= new String[19];
  public Label topicLabel 	= new Label("",Label.CENTER);
  public java.net.URL logouthtml = null;
  public kButton bLogout 	= new kButton();
  public kButton bPrivate 	= new kButton();
  public kButton bModerator 	= new kButton();
  public kButton bClose 	= new kButton();
  public Color foreground 	= new Color(1).decode("#25822E");
  public Color background 	= new Color(1).decode("#A9F0FF");
  public kChatActions actions 	= null;
  public AppletContext context 	= null;
  public Hashtable configParams = new Hashtable();
  private TextField input 	= null;
  private int clickCount 	= 0;

private boolean readParameters() {
    String acceptParams[] = {"login","color","pass","chan","port","moderbutton","textarea_background_image",
			     "color_background","color_foreground","color_button_background",
			     "color_button_foreground","color_textarea_background","color_textarea_foreground"};
    for (int i=0;i<acceptParams.length;i++) {
	String value = new String();
	if ((getParameter(acceptParams[i]) != null) && (!getParameter(acceptParams[i]).equals(""))) {
	    value = getParameter(acceptParams[i]);
	    configParams.put(acceptParams[i],value);	
	    } else {
	    System.out.println("Check parameter \"" + acceptParams[i] + "\" applet stopped");
	    return(false);
	    }
    }
    return(true);
}


public void init() {
 if (!readParameters()) { stop(this.getGraphics()); return; };
 foreground = new Color(1).decode((String)configParams.get("color_foreground"));
 background = new Color(1).decode((String)configParams.get("color_background"));
 msgColor = (String)configParams.get("color");
 
 setLayout(new BorderLayout());
 context  = getAppletContext();
 logouthtml = getDocumentBase();
 
 setBackground(background);
 setForeground(foreground);

 chanWnd = new kChatTextArea(300,5);
 chanWnd.setFont(new Font("fixed", Font.BOLD, 12));
 chanWnd.setBackground(new Color(1).decode((String)configParams.get("color_textarea_background")));
 chanWnd.setForeground(new Color(1).decode((String)configParams.get("color_textarea_foreground")));
 chanWnd.addScroll(sbar);
 chanWnd.autoScroll(true);
 try { 
   chanWnd.setBackgroundImage(getImage(new java.net.URL((String)configParams.get("background"))));
 
 } catch (java.net.MalformedURLException e) { 
   chanWnd.setBackgroundImage(null); 
 }

 actions = new kChatActions(this);

 nList = new List();
 nList.addItemListener(actions);
 nList.addMouseListener(this);
 nList.setBackground(background);
 nList.setForeground(foreground);

 bLogout.setActionCommand("LOGOUT");
 bLogout.addActionListener(actions);
 bLogout.setForeground(new Color(1).decode((String)configParams.get("color_button_foreground")));
 bLogout.setBackground(new Color(1).decode((String)configParams.get("color_button_background")));
 bPrivate.setActionCommand("PRIVATE");
 bPrivate.addActionListener(actions);
 bPrivate.setForeground(new Color(1).decode((String)configParams.get("color_button_foreground")));
 bPrivate.setBackground(new Color(1).decode((String)configParams.get("color_button_background")));
 bModerator.setActionCommand("MODERATOR");
 bModerator.addActionListener(actions);
 bModerator.setForeground(new Color(1).decode((String)configParams.get("color_button_foreground")));
 bModerator.setBackground(new Color(1).decode((String)configParams.get("color_button_background")));

 input = new TextField("");
 input.setFont(new Font("fixed", Font.BOLD, 12));
 input.setBackground(background);
 input.setForeground(foreground);
 input.addKeyListener(this);

 Panel panel = new Panel(new BorderLayout());
 Panel leftP = new Panel(new BorderLayout());
 Panel downP = new Panel(new BorderLayout());
 Panel rightP = new Panel(new BorderLayout());
 Panel kButtonsP = new Panel(new BorderLayout());
 Panel chanwndP = new Panel(new BorderLayout());

 kButtonsP.add(bPrivate, BorderLayout.NORTH);
 if (configParams.get("moderbutton").equals("yes")) kButtonsP.add(bModerator, BorderLayout.CENTER);
 kButtonsP.add(bLogout,BorderLayout.SOUTH);

 rightP.add(nList, BorderLayout.CENTER);
 rightP.add(kButtonsP, BorderLayout.SOUTH);

 chanwndP.add(chanWnd, BorderLayout.CENTER);
 chanwndP.add(sbar, BorderLayout.EAST);
 
 leftP.add(chanwndP, BorderLayout.CENTER);
 leftP.add(rightP, BorderLayout.EAST);

 downP.add(input, BorderLayout.CENTER);

 panel.add(topicLabel, BorderLayout.NORTH);
 panel.add(leftP, BorderLayout.CENTER);
 panel.add(downP, BorderLayout.SOUTH);

 add(panel,BorderLayout.CENTER);
 invalidate();
 doLayout();


 /* Net Thread
 */
 try {
 net = new kChatNet(getCodeBase().getHost(),(String)configParams.get("port"),this);
 } catch (java.io.IOException e) {
    System.out.println("Cannot connect to server !!!");
    stop(this.getGraphics());
    return;
//    e.printStackTrace();
 }

 chan = (String)configParams.get("chan");
 /* get texts
 */
 net.send("*LANG");
 /* login to system
 */
 net.send("*LOGIN|SYSTEM|"+(String)configParams.get("login")+"|"+ (String)configParams.get("pass") +"|"+(String)configParams.get("chan")+"|"+(String)configParams.get("color")+"|");
 /* get users list
 */
 net.send("*CHECK|"+(String)configParams.get("chan")+"|");
 /* get topic of channel
 */
 net.send("*TOPIC|GET|"+(String)configParams.get("chan")+"|");
}

public String compileText(String text,String param) {
    int paramTmp = text.indexOf("%");
    String t = text.substring(0,paramTmp) + param + text.substring(paramTmp+1);
    return(t);
}


public void keyTyped(KeyEvent e) { }
public void keyPressed(KeyEvent e) {
	if ((e.getKeyCode() == KeyEvent.VK_ENTER)
 && (input.getText().length()>0) && (!input.getText().equals(""))) {
		input.getText().trim();
		if (net != null)
		    net.send("*MSG|" + login + "|CHAN|" + input.getText().replace('|',':') + "|" + msgColor + "|");
		input.setText("");
		input.setCaretPosition(0);
	}
}

public void keyReleased(KeyEvent e) {
	if ((e.getKeyCode() == KeyEvent.VK_ENTER)
 && (input.getText().length()>0) && (!input.getText().equals(""))) {
		input.setText("");
		input.setCaretPosition(0);
	}
}


public synchronized void closeAllFloatingWindow() {
 for (int i=0; i < windowsList.size(); i++){
     MsgFloatingWindow tmpMFW = (MsgFloatingWindow)windowsList.elementAt(i);
     tmpMFW.fr.dispose();
     }
 windowsList.removeAllElements();
}


public boolean alreadyExistNick(String nick) {
 for (int i=0; i < windowsList.size(); i++){
     MsgFloatingWindow tmpMFW = (MsgFloatingWindow)windowsList.elementAt(i);
     if (tmpMFW.nick.equals(nick)) return(true);
     }
 return(false);
}


public synchronized MsgFloatingWindow getMsgWindowFromList(String nick) {
 for (int i=0; i < windowsList.size(); i++){
     MsgFloatingWindow tmpMFW = (MsgFloatingWindow)windowsList.elementAt(i);
     if (tmpMFW.nick.equals(nick)) return(tmpMFW);
     }
 return(null);
}



public synchronized void destroy() {
    if (net != null) {
	net.send("*CLOSE");
	net.disconnect();
	net.interrupt();
	context.showDocument(logouthtml,"_self");
	}
}

public void update(Graphics g) { super.paint(g); }
public void start(Graphics g) { repaint(); }
public void run() {
    appletThread = new Thread(this);
    appletThread.start();
    }
    
public void stop(Graphics g) {
    closeAllFloatingWindow();
    if (net != null) {
	net.disconnect();
	net.interrupt();
	net=null;
	}
    appletThread = null;
    }
    
public void paint(Graphics g) { super.paint(g); }


    public void mouseEntered(MouseEvent event) {
    }
    public void mouseExited(MouseEvent event) {
    clickCount = 0;
    }
    public void mousePressed(MouseEvent event) {
    }
    public void mouseReleased(MouseEvent event) {
    if (clickCount > 2) clickCount=0;
    }
    public void mouseClicked(MouseEvent event) {
 
    clickCount++;
    if (clickCount == 2)   { 
    	if ((!(login.equals(selectedNick))) &&
	    (!(selectedNick.equals(""))) &&
	    (alreadyExistNick(selectedNick) == false)) {
	    MsgFloatingWindow fw = new MsgFloatingWindow(compileText(TXT[12],selectedNick),selectedNick,this);
	    fw.setVisible(true);
	    /*
	    try {
	    play(new java.net.URL(soundFile));
	    } catch (java.net.MalformedURLException ee) {}
	    */
	   }
	}
    }



}
